
% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% convert original video to *.mpg format by ffmpeg, so that the video files can be processed by matlab
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


oldRoot  = '..\..\DataSet\';
newRoot  = '..\video_db\';
newRoot2 = '..\video_annotation\';
CNV_PROG = '..\tools\converter\ffmpeg.exe';

videoListFile = '..\..\DataSet\annotationList.txt';
videoInfo = textread(videoListFile, '%s', 'delimiter', '\n');
annoFile  = fopen('annotationList.txt', 'wt');
for vIdx=1:length(videoInfo)
    details = regexp(videoInfo{vIdx}, ';', 'split');
    origAnnoFile = [oldRoot  strtrim(details{1})];
    origVideoFile= [oldRoot  strtrim(details{2})];
    if exist(origAnnoFile, 'file') && exist(origVideoFile, 'file')
        [oldPath,fileName,fileExt] = fileparts(origVideoFile);
        newVideoFile = fullfile(newRoot, [fileName,'.mpg']);
        newAnnoFile  = fullfile(newRoot2, [fileName,'.txt']);
        % -an    no audio
        % -b:v   video bit rate
        if ~exist(newVideoFile, 'file') || vIdx>=190 && vIdx<=203
            cmd = sprintf('%s -i %s -an -s 640x480 -b:v 2000k %s', ...
                CNV_PROG, origVideoFile, newVideoFile);
            system(cmd);
        end;
        if ~exist(newAnnoFile, 'file')
            copyfile(origAnnoFile, newAnnoFile);
        end;
        fprintf(annoFile, '%s; %s\n', newAnnoFile, newVideoFile);
    end;
end;
fclose(annoFile);
