% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.


function funcMusicRecommend_Main(videoAnnoFile, videoMpgFile, musicListFile)
% clear all; close all;

if ~exist(videoAnnoFile,'file')
    fprintf(2, 'Annotation file (%s) does not exist\n', videoAnnoFile);
end;
if ~exist(videoMpgFile,'file')
    fprintf(2, 'Video file (%s) does not exist\n', videoMpgFile);
end;

config = getConfig;

load(config.geoTagMoodInfoFile);
% 'geoTagSet', 'moodTagSet'

load(config.geoFeatFile);
% 'annotationInfo().geoTagFeat'
% 'annotationInfo().startTime'
% 'annotationInfo().endTime'

load(config.visualFeatFile);
% 'visualFeat().visualFeat'
% 'visualFeat().frameTime'

load(config.audioFeatFile);
load(config.audioBucketFile);
% 'musicGenreSet', 'musicDb', 'musicBucket', 'musicGenreInfo'


% ----------- 5. music recommendation -------------------------------------
% test 3
% videoIndex = 352;  % annotationInfo().geoTagFeat, visualFeat().visualFeat    
% videoAnnoFile = '..\video_annotation\eea41a2605_2013_03_03_10_31_41_AM_GMT_08_00.txt';
% videoMpgFile  = '..\video_db\test.mpg'; % '..\video_db\eea41a2605_2013_03_03_10_31_41_AM_GMT_08_00.mpg';

recommend = funcMusicRecommend(videoAnnoFile,videoMpgFile, config, geoTagSet, moodTagSet, musicDb, musicBucket);

numRecommendSong = numel(recommend.songIdxSet);
fid = fopen(musicListFile, 'wt');
for k=1:numRecommendSong
    audioIdx = recommend.songIdxSet(k);
    rootPathLen = length(config.musicRoot);
    fprintf(fid, '%s\n', musicDb(audioIdx).trackName(rootPathLen+1:end));
end;
fclose(fid);


%     cfg = coder.config('lib');
%     cfg.TargetLang = 'C'; % 'C++';
%     codegen -c -d build1 -config cfg -report funcMusicRecommend.m -args {videoAnnoFile,videoMpgFile, config, geoTagSet, moodTagSet, musicDb, musicBucket}
%     funcMusicRecommend_mex(videoAnnoFile,videoMpgFile, config, geoTagSet, moodTagSet, musicDb, musicBucket);
