% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.



function [geoTagSet, moodTagSet] = getAnnotationSet(annotationListFile, usePrimaryMoodOnly)

numGeoTag = 0;
geoTagSet = [];
numMoodTag= 0;
moodTagSet= [];

annotationList = textread(annotationListFile, '%s', 'delimiter', '\n');
for fIdx=1:numel(annotationList);
    % fprintf('fIdx=%d\n', fIdx);
    annoFileInfo = annotationList{fIdx};
    videoInfo = regexp(annoFileInfo, ';', 'split');
    annoFileName = strtrim(videoInfo{1});
    
    thisAnnotationInfo = textread(annoFileName, '%s', 'delimiter', '\n');
    for aIdx=1:numel(thisAnnotationInfo)
        segDetail = regexp(thisAnnotationInfo{aIdx}, ';', 'split');

        % get geo-tags per segment
        geoTagStr = segDetail{1};
        geoTagInfo = regexp(geoTagStr, ',', 'split');
        geoTagSav = '';
        for k=1:2:numel(geoTagInfo)
            numGeoTag = numGeoTag+1;
            geoTagSet{numGeoTag} = lower(strtrim(geoTagInfo{k}));
            geoTagSav = [geoTagSav ';' lower(strtrim(geoTagInfo{k}))];
        end;
        % fprintf('geoTag %3d: %s\n', fIdx, geoTagSav); 
        
        % get mood-tags per segment
        moodTagStr = segDetail{2};
        moodTagInfo = regexp(moodTagStr, ',', 'split');
        moodTagSav = '';
        for k=1:numel(moodTagInfo)
            numMoodTag = numMoodTag+1;
            moodTagSet{numMoodTag} = lower(strtrim(moodTagInfo{k}));
            moodTagSav = [moodTagSav ';' lower(strtrim(moodTagInfo{k}))];
            if usePrimaryMoodOnly
                % currently only consider the first mood tag
                break;    
            end;
        end;
        % fprintf('moodTag%3d: %s\n', fIdx, moodTagSav); 
    end;
end;

geoTagSet = unique(geoTagSet);
moodTagSet= unique(moodTagSet);
