% Copyright 2013, Yi Yu <yuy@comp.nus.edu.sg>
% This program is for Personal Music Video Generation based on Modeling Scene Moods and is free: 
% You can redistribute it and/or modify
% it under the terms of the GNU General Public License.



function getAudioFeatures(FEAT_FILE)
% FEAT_FILE = 'features.mat';

addpath('mp3readwrite');
pestLabelFile = 'classLabel_train.txt';
dataPath  = '..\';

pestLabelCell = textread(pestLabelFile, '%s', 'delimiter', '\n');
pestLabelInfo = zeros(length(pestLabelCell),2);

feat = [];
for sIdx=1:length(pestLabelCell)
    fileInfo = regexp(pestLabelCell{sIdx}, '\s+', 'split');
    fileName = fullfile(dataPath, fileInfo{1});
    classId  = str2num(fileInfo{2});
    [data, data_fs, mbits] = mp3read(fileName);
    fprintf('sIdx:%03d, Fs:%d, Channel:%d, Size:%7d, %s, ok\n', sIdx, data_fs, size(data,2), length(data), fileName);

    sig{1} = data;
    [tmpFeat, drawInfo] = extract_feat(sig);
    feat{sIdx} = tmpFeat{1};
    pestLabelInfo(sIdx,:) = [sIdx, classId];
end;
save(FEAT_FILE, 'feat', 'pestLabelInfo');
return;
