function path = viterbi_svm_Nbest(svmhmm, featSeq)

emitW = svmhmm.emitW;
transW= svmhmm.transW;

% score due to emit only
obslik = emitW * featSeq';

[Q,T] = size(obslik);
score = zeros(Q,T);
psi = zeros(Q,T);
path = zeros(1,T); % optimal path


t=1;
score(:,t) = obslik(:,t);
psi(:,t) = 0; % arbitrary value, since there is no predecessor to t=1

for t=2:T
  for j=1:Q
    pj = score(:,t-1) + transW(:,j) + obslik(j,t);
    [score(j,t), psi(j,t)] = max(pj);
  end
end
[p, path(T)] = max(score(:,T));

for t=T-1:-1:1
  path(t) = psi(path(t+1),t+1);
end
return;
